---
title: <script>
slug: Web/SVG/Element/script
tags:
  - Element
  - Reference
  - SVG
---
<p>The SVG <code>script</code> element allows to add scripts to an SVG document.</p>

<p class="note">While SVG's <code>script</code> element is equivalent to the HTML {{HTMLElement('script')}} element, it has some discrepancies, like it uses the {{SVGAttr('href')}} attribute instead of {{htmlattrxref('src','script')}} and it doesn't support ECMAScript modules so far (See browser compatibility below for details)</p>

<div id="Exemple">
<div class="hidden">
<pre class="brush: css">html,body,svg { height:100% }</pre>
</div>

<pre class="brush: html; highlight[4]">&lt;svg viewBox="0 0 10 10" xmlns="http://www.w3.org/2000/svg"&gt;
  &lt;script&gt;
  // &lt;![CDATA[
  window.addEventListener('DOMContentLoaded', () =&gt; {
    function getColor () {
      const R = Math.round(Math.random() * 255).toString(16).padStart(2,'0')
      const G = Math.round(Math.random() * 255).toString(16).padStart(2,'0')
      const B = Math.round(Math.random() * 255).toString(16).padStart(2,'0')
      return `#${R}${G}${B}`
    }

    document.querySelector('circle').addEventListener('click', (e) =&gt; {
      e.target.style.fill = getColor()
    })
  })
  // ]]&gt;
  &lt;/script&gt;

  &lt;circle cx="5" cy="5" r="4" /&gt;
&lt;/svg&gt;</pre>

<p>{{EmbedLiveSample('Exemple', 150, '100%')}}</p>
</div>

<h2 id="Attributes">Attributes</h2>

<dl>
 <dt id="attr-cx">{{htmlattrxref("crossorigin", "script")}}</dt>
 <dd>This attribute defines <a href="/docs/Web/HTML/CORS_settings_attributes">CORS settings</a> as define for the HTML {{HTMLElement('script')}} element.<br>
 <small><em>Value type</em>: <a href="/docs/Web/SVG/Content_type#String"><strong>&lt;string&gt;</strong></a>; <em>Default value</em>: <code>?</code>; <em>Animatable</em>: <strong>yes</strong></small></dd>
 <dt>{{SVGAttr("href")}}</dt>
 <dd>The {{Glossary("URL")}} to the script to load.<br>
 <small><em>Value type</em>: <strong><a href="/docs/Web/SVG/Content_type#URL">&lt;URL&gt;</a></strong> ; <em>Default value</em>: <em>none</em>; <em>Animatable</em>: <strong>no</strong></small></dd>
 <dt id="attr-cx">{{SVGAttr("type")}}</dt>
 <dd>This attribute defines type of the script language to use.<br>
 <small><em>Value type</em>: <a href="/docs/Web/SVG/Content_type#String"><strong>&lt;string&gt;</strong></a>; <em>Default value</em>: <code>application/ecmascript</code>; <em>Animatable</em>: <strong>no</strong></small></dd>
 <dt>{{SVGAttr("xlink:href")}} {{deprecated_inline("SVG2")}}</dt>
 <dd>The {{Glossary("URL")}} to the script to load.<br>
 <small><em>Value type</em>: <strong><a href="/docs/Web/SVG/Content_type#URL">&lt;URL&gt;</a></strong> ; <em>Default value</em>: <em>none</em>; <em>Animatable</em>: <strong>no</strong></small></dd>
</dl>

<h3 id="Global_attributes">Global attributes</h3>

<dl>
 <dt><a href="/docs/Web/SVG/Attribute/Core">Core Attributes</a></dt>
 <dd><small>Most notably: {{SVGAttr('id')}}</small></dd>
 <dt><a href="/docs/Web/SVG/Attribute/Styling">Styling Attributes</a></dt>
 <dd><small>{{SVGAttr('class')}}, {{SVGAttr('style')}}</small></dd>
 <dt>Event Attributes</dt>
 <dd><small><a href="/docs/Web/SVG/Attribute/Events#Global_Event_Attributes">Global event attributes</a>, <a href="/docs/Web/SVG/Attribute/Events#Document_Element_Event_Attributes">Document element event attributes</a></small></dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>{{svginfo}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('SVG2', 'interact.html#ScriptElement', '&lt;script&gt;')}}</td>
   <td>{{Spec2('SVG2')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('SVG1.1', 'script.html#ScriptElement', '&lt;script&gt;')}}</td>
   <td>{{Spec2('SVG1.1')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("svg.elements.script")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/HTML/Element/Script"><code>script</code> element in HTML</a></li>
</ul>

<p>{{SVGRef}}</p>
